<?php

namespace Slack\Jobs;

use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Queue\SerializesModels;
use Illuminate\Support\Arr;
use Illuminate\Support\Collection;

abstract class Job implements ShouldQueue
{
    /*
    |--------------------------------------------------------------------------
    | Queueable Jobs
    |--------------------------------------------------------------------------
    |
    | This job base class provides a central location to place any logic that
    | is shared across all of your jobs. The trait included with the class
    | provides access to the "queueOn" and "delay" queue helper methods.
    |
    */

    use InteractsWithQueue, Queueable, SerializesModels;

    protected Collection $_data;

	public function __get($key)
	{
		if (! isset($this->_data))
			$this->_data = collect();

		return Arr::get($this->_data,$key);
	}

	public function __set(string $key,$value) {
		if (! isset($this->_data))
			$this->_data = collect();

		return $this->_data->put($key,$value);
	}
}