<?php

namespace Slack\Listeners;

use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Support\Facades\Log;

use Slack\Options\BlockSuggestion;

class BlockSuggestionListener implements ShouldQueue
{
	private const LOGKEY = 'LBS';

	public $queue = 'slack';

	/**
	 * Handle the event.
	 *
	 * @note Since BlockSuggestions are interactive, it is unlikely that this is needed.
	 * @param BlockSuggestion $event
	 * @return void
	 * @throws \Exception
	 */
	public function handle(BlockSuggestion $event): void
	{
		// Do some magic with event data
		Log::info(sprintf('%s:Block Suggestion for Callback [%s] User [%s] in [%s]',self::LOGKEY,$event->callback_id,$event->user_id,$event->team_id),['e'=>$event]);
	}
}