<?php

namespace Slack\Options;

use Illuminate\Support\Facades\Log;

use Slack\Message;

/**
 * Catch all unknown slack event that we havent specifically programmed for.
 *
 * @package Slack\Options
 */
final class Unknown extends Base
{
	protected const LOGKEY = 'OU-';

	public function __construct(array $request)
	{
		Log::notice(sprintf('SOU:UNKNOWN Slack Interaction Option received [%s]',get_class($this)),['m'=>__METHOD__]);

		parent::__construct($request);
	}

	/**
	 * Interactive messages can return their output in the incoming HTTP post
	 *
	 * @return Message
	 */
	public function respond(): Message
	{
		Log::info(sprintf('%s:Unknown Option - Callback [%s] Name [%s] Value [%s]',static::LOGKEY,$this->callback_id,$this->name,$this->value),['m'=>__METHOD__]);

		Log::notice(sprintf('%s:Unhandled CALLBACK [%s]',static::LOGKEY,$this->callback_id),['m'=>__METHOD__]);

		return Message::blank();
	}
}